"""
- Développement d'une interface graphique avec la bibliothèque tkinter pour :
afficher le résultat des données récupérées via une requête SQL
- Placer un bouton radio avec deux choix pour lencer deux requêtes différentes
"""
# Importation des bibliothèques python
import sqlite3
from tkinter import *    # Interface graphique
from tkinter.messagebox import *
    
def lancer_requete ( ) :
    global config_requete
    global fenetre_data
    
    connecteur = sqlite3.connect("facturation.sqlite")
    curseur = connecteur.cursor()

    fenetre_data.delete(0,fenetre_data.size()) # Efffacer la fenêtre d'affichage de données
    fenetre_data.insert(0,"====== Résultat de la requête ======")

    table = config_requete.get()
    if table == "client" :
        curseur.execute("""SELECT * FROM CLIENTS ORDER BY VILLE""")
        txt_result = "...Réf    "+"."*43+"SOCIETE    "+"."*35+"VILLE"             
    else :
        curseur.execute("""SELECT * FROM PRODUITS ORDER BY PRIX_UNITAIRE""")
        txt_result = "Réf ..................................PRODUIT    ...PRIX"             
    fenetre_data.insert(1,txt_result)
    cptr_ligne=1 # compteur de lignes dans la fenêtre d'affichage
    cptr_pos=1

    result = curseur.fetchall()
    curseur.close()
    
    for enreg in result:
        cptr_pos = cptr_pos + 1
        cptr_ligne = cptr_ligne + 1
        if table=="client":
            txt_result = "{: >6s}    {: >50s}    {: >20s}".format(enreg[0],enreg[1],enreg[3])             
        else :
            txt_result = "{: >3d} {: >35s}     {:> 5.2f} €".format(enreg[0],enreg[1],enreg[2])             
        fenetre_data.insert(cptr_ligne,txt_result)
            
# ============================================= Programme principal

# ===============  Créer l'interface graphique

    # Créer la fenêtre principale
monAppli = Tk()    
monAppli.title (">====> Résultat d'une requête <=====<")
monAppli.geometry("980x600")
monAppli.config(bg='#0080A0') # Couleur fond
    # Créer une zone d'affichage des données avec un ascenseur sur le côté
zone_data = Frame ( monAppli ) 
zone_data.grid(row=0, column=0, padx=10, pady=10)
    # Créer une zone de conrôle de l'application
    
zone_control = Frame ( monAppli, bg='#D0D0F0' ) 
zone_control.grid(row=1, column=0, padx=10, pady=10)

    # -> ZONE_DATA -> Créer la frame d'affichage des données 
fenetre_data = Listbox( zone_data, bg='#A0A0C0',
                        height=25, width=100, relief='groove' ) # Affichage des données
ascen_data = Scrollbar( zone_data,  bg='#D0D0F0', relief='groove') # Ascenceur
fenetre_data.config ( yscrollcommand = ascen_data.set )
ascen_data.config ( command = fenetre_data.yview )
fenetre_data.pack( side=LEFT, padx=10, pady=10  )
ascen_data.pack( side=RIGHT, padx=10, pady=10   )
fenetre_data.insert(1,"Attente de la requête ...")

    # -> ZONE_CONTROL -> Créer une zone de configuration
config_requete = StringVar()
config_requete.set("client")

config_label = Label (zone_control, text="Configurer la requête :",
                      fg='#202040', bg='#D0D0F0', height=1)
config_label.grid(row=0, column=1, padx=10 )

config_client = Radiobutton ( zone_control, text="Liste des clients",
                           value="client", variable=config_requete,
                           height=1, width=20, bg='#D0D0F0')
config_client.grid(row=1, column=1, padx=30 )

config_produit = Radiobutton ( zone_control, text="Liste des produits",
                           value="produit", variable=config_requete,
                           height=1, width=20, bg='#D0D0F0')
config_produit.grid(row=2, column=1, pady=5 )

    # Créer une zone de commande avec les boutons [ Enregistrer ] et [ Quitter ]

requete = Button ( zone_control, text="[ Lancer la requête ]", state='normal',
                          height=2, width=20, relief='groove', command=lancer_requete )
requete.grid(row=1, column=2, padx=30, pady=5 )

quitter = Button ( zone_control, text=" QUITTER ",
                   height=2, width=20, relief='groove', command=monAppli.quit )
quitter.grid(row=1, column=3, padx=30, pady=5 )


#Interface graphique dans la Thread principale
monAppli.mainloop()
monAppli.destroy()